
/*----------------
  QMC5883L hookup to Arduino Uno / Nano. For other boards see  [Arduino Wire Reference](https://www.arduino.cc/en/Reference/Wire)
  VCC  O ---- O +5v
  GND  O ---- O GND
  SCL  O ---- O A5
  SDA  O ---- O A4
  DRDY O ---- X NOT CONNECTED

 ----------------*/

//#define DLC   // only if liquid crystal display 
//#include <LiquidCrystal.h> 
#include <QMC5883LCompass.h>

QMC5883LCompass compass;
//LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

void setup() {
#ifdef DLC	
  lcd.begin(20, 4);
  lcd.clear();
#else
  Serial.begin(9600);
#endif
  compass.init();
}

void loop() {

  int x, y, z, a;
  byte b;
  char myArray[3];
  
  compass.read();
  
  x = compass.getX();
  y = compass.getY();
  z = compass.getZ();
  
  a = compass.getAzimuth();
  
  b = compass.getBearing(a);

  compass.getDirection(myArray, a);
  
#ifdef DLC
  lcd.setCursor(0,0);
  lcd.print("X=");
  lcd.print(x);
  lcd.setCursor(8,0);
  lcd.print("Y=");
  lcd.print(y);

  lcd.setCursor(0,1);
  lcd.print("azimuth=");
  lcd.print(a);

  lcd.setCursor(0,2);
  lcd.print("bearing=");
  lcd.print(b);
    
#else  // ASC.exe
  Serial.print("START");
  
  Serial.print("X: ");
  Serial.print(x);
  Serial.print(" Y: ");
  Serial.print(y);
  Serial.print(" Z: ");
  Serial.print(z);
  Serial.println();
  
  Serial.print(" Azimuth: ");
  Serial.print(a);
  Serial.println();
  
  Serial.print(" Bearing: ");
  Serial.print(b);
  Serial.println();
  
  Serial.print(" Direction: ");
  Serial.print(myArray[0]);
  Serial.print(myArray[1]);
  Serial.print(myArray[2]);
  Serial.println();
  
  Serial.print("STOP");
  
#endif

  delay(250);
}
